﻿'Developed By Dynamics360. Copyright All rights reserved.

Imports System.Data.SqlClient
Imports System.IO
Imports System.Windows.Forms


Public Class Form1
    Public Const DIAMOND_INVOICE_FILE_HEADER_LINES As Integer = 4
    'Public MyList As List(Of DataGridViewRow) = New List(Of DataGridViewRow)
    Private _connString As String
    Private IsFirstTime As Boolean = False

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Me._connString = GetDBConnectionString()
        Dim fd As OpenFileDialog = New OpenFileDialog
        Dim FilePath As String
        fd.Title = "Select .CSV File"
        fd.InitialDirectory = "C:\"
        fd.Filter = "CSV Files (*.csv)|*.csv|All files (*.*)|*.*"
        fd.FilterIndex = 1
        fd.RestoreDirectory = True
        If fd.ShowDialog() = DialogResult.OK Then
            FilePath = fd.FileName
            If File.Exists(FilePath) Then
                ImportInvoiceFile(FilePath)
                'Dim constr As String = GetDBConnectionString()

                'Dim query As String = "SELECT Quantity,StockNumber,ProductTitle,CoverPrice FROM InvoiceProduct;"

                'Using con As New SqlConnection(constr)
                '    Using cmd As New SqlCommand(query)
                '        Using sda As New SqlDataAdapter()
                '            cmd.Connection = con
                '            sda.SelectCommand = cmd
                '            Using ds As New DataSet()
                '                sda.Fill(ds)
                '                DataGridView1.DataSource = ds.Tables(0)
                '                IsFirstTime = True
                '            End Using
                '        End Using
                '    End Using
                'End Using
                FillTheGrid()
            Else
                MessageBox.Show("File does not exists")
            End If
        End If

    End Sub
    Public Sub FillTheGrid()
        Dim constr As String = GetDBConnectionString()

        Dim query As String = "SELECT Quantity,StockNumber,ProductTitle,CoverPrice FROM InvoiceProduct;"

        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query, con)
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using ds As New DataSet()
                        sda.Fill(ds)
                        DataGridView1.DataSource = ds.Tables(0)
                        IsFirstTime = True
                    End Using
                End Using
            End Using
        End Using
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Me.Close()
    End Sub
    Public Sub SaveGridChanges()


    End Sub
    Public Sub AddInvoiceProduct(ByVal qty As Integer, ByVal stockNumber As String, ByVal title As String, ByVal coverPrice As Decimal)
        Using sqlConnection As System.Data.SqlClient.SqlConnection = New System.Data.SqlClient.SqlConnection(GetDBConnectionString())
            sqlConnection.Open()
            Using sqlCommand As System.Data.SqlClient.SqlCommand = New System.Data.SqlClient.SqlCommand("AddInvoiceProduct", sqlConnection) With
                {
                    .CommandType = CommandType.StoredProcedure
                }
                Dim sqlParameter As System.Data.SqlClient.SqlParameter = New System.Data.SqlClient.SqlParameter("@Qty", SqlDbType.Int) With
                    {
                        .Direction = ParameterDirection.Input
                    }
                sqlCommand.Parameters.Add(sqlParameter)
                sqlCommand.Parameters("@Qty").Value = qty
                Dim sqlParameter1 As System.Data.SqlClient.SqlParameter = New System.Data.SqlClient.SqlParameter("@StockNumber", SqlDbType.VarChar, 15) With
                    {
                        .Direction = ParameterDirection.Input
                    }
                sqlCommand.Parameters.Add(sqlParameter1)
                sqlCommand.Parameters("@StockNumber").Value = stockNumber
                Dim sqlParameter2 As System.Data.SqlClient.SqlParameter = New System.Data.SqlClient.SqlParameter("@ProductTitle", SqlDbType.VarChar, 75) With
                    {
                        .Direction = ParameterDirection.Input
                    }
                sqlCommand.Parameters.Add(sqlParameter2)
                sqlCommand.Parameters("@ProductTitle").Value = title
                Dim sqlParameter3 As System.Data.SqlClient.SqlParameter = New System.Data.SqlClient.SqlParameter("@CoverPrice", SqlDbType.Money) With
                    {
                        .Direction = ParameterDirection.Input
                    }
                sqlCommand.Parameters.Add(sqlParameter3)
                sqlCommand.Parameters("@CoverPrice").Value = coverPrice
                sqlCommand.ExecuteNonQuery()
            End Using
        End Using
    End Sub

    Public Shared Function GetDBConnectionString() As String
        Dim str() As String
        Dim ConnString As String = ""
        If File.Exists("C:\Program Files (x86)\Microsoft Retail Management System\Store Operations\AddIns\DiamondInvoiceConfig.txt") Then
            Using Sr As StreamReader = New StreamReader("C:\Program Files (x86)\Microsoft Retail Management System\Store Operations\AddIns\DiamondInvoiceConfig.txt")
                Dim line As String
                line = Sr.ReadLine()
                str = line.Split(":")
                Dim Part As String
                For Each Part In str
                    ConnString = Part
                Next
            End Using
        Else
            MessageBox.Show("Configuration file does not exists in Add-ins folder")
        End If
        'ConnString = "Data Source=JRTABLET;Persist Security Info=True;User ID=sa;password=legion1978;Initial Catalog=GrahamCrackers"
        Return ConnString
    End Function

    Public Shared Function GetRMSDBConnectionString() As String
        Dim str() As String
        Dim ConnString As String = ""
        If File.Exists("C:\Program Files (x86)\Microsoft Retail Management System\Store Operations\AddIns\DiamondInvoiceConfig.txt") Then
            Using Sr As StreamReader = New StreamReader("C:\Program Files (x86)\Microsoft Retail Management System\Store Operations\AddIns\DiamondInvoiceConfig.txt")
                Dim line As String
                line = Sr.ReadLine()
                line = Sr.ReadLine()
                str = line.Split(":")
                Dim Part As String
                For Each Part In str
                    ConnString = Part
                Next
            End Using
        Else
            MessageBox.Show("Configuration file does not exists in Add-ins folder")
        End If
        Return ConnString
    End Function

    Public Sub ImportInvoiceFile(ByVal fileName As String)
        Dim streamReader As System.IO.StreamReader = New System.IO.StreamReader(File.OpenRead(fileName))
        For i As Integer = 1 To 4
            streamReader.ReadLine()
        Next

        While Not streamReader.EndOfStream
            Dim str As String = streamReader.ReadLine()
            Dim strArrays As String() = str.Split(New Char() {","c})
            Dim num As Integer = Integer.Parse(strArrays(0))
            Dim str1 As String = strArrays(1).Replace("""", String.Empty)
            Dim str2 As String = strArrays(3).Replace("""", String.Empty)
            Dim num1 As Decimal = Decimal.Parse(strArrays(4))
            Me.AddInvoiceProduct(num, str1, str2, num1)
        End While
    End Sub

    Public Sub ProcessDiamondInvoice()
        Using sqlConnection As System.Data.SqlClient.SqlConnection = New System.Data.SqlClient.SqlConnection(GetDBConnectionString())
            sqlConnection.Open()
            Using sqlCommand As System.Data.SqlClient.SqlCommand = New System.Data.SqlClient.SqlCommand("ProcessDiamondInvoice", sqlConnection) With
                {
                    .CommandType = CommandType.StoredProcedure
                }
                sqlCommand.ExecuteNonQuery()
            End Using
        End Using
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click 'UPDATE RMS
        ProcessDiamondInvoice()

        Dim constr As String = GetDBConnectionString()
        Dim delQuery As String = "DELETE FROM InvoiceProduct WHERE DateProcessed IS NOT NULL"

        Using con As New SqlConnection(constr)
            con.Open()
            Using delCMD As New SqlCommand(delQuery, con)
                delCMD.ExecuteNonQuery()

            End Using
            con.Close()
        End Using

        MessageBox.Show("Successfully RMSUpdated")
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click 'SAVE BUTTON

        Dim constr As String = GetDBConnectionString()

        Dim delQuery As String = "Delete from InvoiceProduct"

        Using con As New SqlConnection(constr)
            con.Open()
            Using delCMD As New SqlCommand(delQuery, con)
                delCMD.ExecuteNonQuery()
                For Each row As DataGridViewRow In DataGridView1.Rows
                    Me.AddInvoiceProduct(Integer.Parse(row.Cells(0).Value.ToString()), row.Cells(1).Value.ToString(), row.Cells(2).Value.ToString(), Decimal.Parse(row.Cells(3).Value.ToString()))
                Next

            End Using
        End Using
        MessageBox.Show("Invoice Successfully Saved")

    End Sub



    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click 'REFRESH
        If IsFirstTime Then
            Dim constr As String = GetDBConnectionString()

            Dim query As String = "SELECT Quantity,StockNumber,ProductTitle,CoverPrice FROM InvoiceProduct;"

            Using con As New SqlConnection(constr)
                Using cmd As New SqlCommand(query, con)
                    Using sda As New SqlDataAdapter()
                        cmd.Connection = con
                        sda.SelectCommand = cmd
                        Using ds As New DataSet()
                            sda.Fill(ds)
                            DataGridView1.DataSource = ds.Tables(0)
                        End Using
                    End Using
                End Using
            End Using
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        FillTheGrid()
    End Sub

    'Delete rows button
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        If DataGridView1.SelectedRows.Count > 0 Then
            For Each row As DataGridViewRow In DataGridView1.SelectedRows
                DataGridView1.Rows.Remove(row)
            Next
        Else
            MessageBox.Show("Please select at least one row to delete.")
        End If
    End Sub
End Class